/*
GooBer CPU core. 
Copyright (C) 2002 Ian Smith

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* SWAP n --------------------------------------------------------------- */
case 0x37: sprintf(out, "SWAP A\n"); break;
case 0x30: sprintf(out, "SWAP B\n"); break;
case 0x31: sprintf(out, "SWAP C\n"); break;
case 0x32: sprintf(out, "SWAP D\n"); break;
case 0x33: sprintf(out, "SWAP E\n"); break;
case 0x34: sprintf(out, "SWAP H\n"); break;
case 0x35: sprintf(out, "SWAP L\n"); break;
case 0x36: sprintf(out, "SWAP (HL)\n"); break;

case 0x07: sprintf(out, "RLC A\n"); break;
case 0x00: sprintf(out, "RLC B\n"); break;
case 0x01: sprintf(out, "RLC C\n"); break;
case 0x02: sprintf(out, "RLC D\n"); break;
case 0x03: sprintf(out, "RLC E\n"); break;
case 0x04: sprintf(out, "RLC H\n"); break;
case 0x05: sprintf(out, "RLC L\n"); break;
case 0x06: sprintf(out, "RLC (HL)\n"); break;

case 0x17: sprintf(out, "RL A\n"); break;
case 0x10: sprintf(out, "RL B\n"); break;
case 0x11: sprintf(out, "RL C\n"); break;
case 0x12: sprintf(out, "RL D\n"); break;
case 0x13: sprintf(out, "RL E\n"); break;
case 0x14: sprintf(out, "RL H\n"); break;
case 0x15: sprintf(out, "RL L\n"); break;
case 0x16: sprintf(out, "RL (HL)\n"); break;

case 0x0F: sprintf(out, "RRC A\n"); break;
case 0x08: sprintf(out, "RRC B\n"); break;
case 0x09: sprintf(out, "RRC C\n"); break;
case 0x0A: sprintf(out, "RRC D\n"); break;
case 0x0B: sprintf(out, "RRC E\n"); break;
case 0x0C: sprintf(out, "RRC H\n"); break;
case 0x0D: sprintf(out, "RRC L\n"); break;
case 0x0E: sprintf(out, "RRC (HL)\n"); break;

case 0x1F: sprintf(out, "RR A\n"); break;
case 0x18: sprintf(out, "RR B\n"); break;
case 0x19: sprintf(out, "RR C\n"); break;
case 0x1A: sprintf(out, "RR D\n"); break;
case 0x1B: sprintf(out, "RR E\n"); break;
case 0x1C: sprintf(out, "RR H\n"); break;
case 0x1D: sprintf(out, "RR L\n"); break;
case 0x1E: sprintf(out, "RR (HL)\n"); break;

case 0x27: sprintf(out, "SLA A\n"); break;
case 0x20: sprintf(out, "SLA B\n"); break;
case 0x21: sprintf(out, "SLA C\n"); break;
case 0x22: sprintf(out, "SLA D\n"); break;
case 0x23: sprintf(out, "SLA E\n"); break;
case 0x24: sprintf(out, "SLA H\n"); break;
case 0x25: sprintf(out, "SLA L\n"); break;
case 0x26: sprintf(out, "SLA (HL)\n"); break;

case 0x2F: sprintf(out, "SRA A\n"); break;
case 0x28: sprintf(out, "SRA B\n"); break;
case 0x29: sprintf(out, "SRA C\n"); break;
case 0x2A: sprintf(out, "SRA D\n"); break;
case 0x2B: sprintf(out, "SRA E\n"); break;
case 0x2C: sprintf(out, "SRA H\n"); break;
case 0x2D: sprintf(out, "SRA L\n"); break;
case 0x2E: sprintf(out, "SRA (HL)\n"); break;

case 0x3F: sprintf(out, "SRL A\n"); break;
case 0x38: sprintf(out, "SRL B\n"); break;
case 0x39: sprintf(out, "SRL C\n"); break;
case 0x3A: sprintf(out, "SRL D\n"); break;
case 0x3B: sprintf(out, "SRL E\n"); break;
case 0x3C: sprintf(out, "SRL H\n"); break;
case 0x3D: sprintf(out, "SRL L\n"); break;
case 0x3E: sprintf(out, "SRL (HL)\n"); break;

case 0x47: sprintf(out, "BIT %.2x, A\n", READ_B(offset++)); break;
case 0x40: sprintf(out, "BIT %.2x, B\n", READ_B(offset++)); break;
case 0x41: sprintf(out, "BIT %.2x, C\n", READ_B(offset++)); break;
case 0x42: sprintf(out, "BIT %.2x, D\n", READ_B(offset++)); break;
case 0x43: sprintf(out, "BIT %.2x, E\n", READ_B(offset++)); break;
case 0x44: sprintf(out, "BIT %.2x, H\n", READ_B(offset++)); break;
case 0x45: sprintf(out, "BIT %.2x, L\n", READ_B(offset++)); break;
case 0x46: sprintf(out, "BIT %.2x, (HL)\n", READ_B(offset++)); break;

case 0xC7: sprintf(out, "SET %.2x, A\n", READ_B(offset++)); break;
case 0xC0: sprintf(out, "SET %.2x, B\n", READ_B(offset++)); break;
case 0xC1: sprintf(out, "SET %.2x, C\n", READ_B(offset++)); break;
case 0xC2: sprintf(out, "SET %.2x, D\n", READ_B(offset++)); break;
case 0xC3: sprintf(out, "SET %.2x, E\n", READ_B(offset++)); break;
case 0xC4: sprintf(out, "SET %.2x, H\n", READ_B(offset++)); break;
case 0xC5: sprintf(out, "SET %.2x, L\n", READ_B(offset++)); break;
case 0xC6: sprintf(out, "SET %.2x, (HL)\n", READ_B(offset++)); break;

case 0x87: sprintf(out, "RES %.2x, A\n", READ_B(offset++)); break;
case 0x80: sprintf(out, "RES %.2x, B\n", READ_B(offset++)); break;
case 0x81: sprintf(out, "RES %.2x, C\n", READ_B(offset++)); break;
case 0x82: sprintf(out, "RES %.2x, D\n", READ_B(offset++)); break;
case 0x83: sprintf(out, "RES %.2x, E\n", READ_B(offset++)); break;
case 0x84: sprintf(out, "BES %.2x, H\n", READ_B(offset++)); break;
case 0x85: sprintf(out, "RES %.2x, L\n", READ_B(offset++)); break;
case 0x86: sprintf(out, "RES %.2x, (HL)\n", READ_B(offset++)); break;











