/*
GooBer CPU core. 
Copyright (C) 2002 Ian Smith

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* LD r, n ---------------------------------------------------------------- */
case 0x06: sprintf(out, "LD B, %.2x\n", READ_B(offset++)); break;
case 0x0E: sprintf(out, "LD C, %.2x\n", READ_B(offset++)); break;
case 0x16: sprintf(out, "LD D, %.2x\n", READ_B(offset++)); break;
case 0x1E: sprintf(out, "LD E, %.2x\n", READ_B(offset++)); break;
case 0x26: sprintf(out, "LD H, %.2x\n", READ_B(offset++)); break;
case 0x2E: sprintf(out, "LD L, %.2x\n", READ_B(offset++)); break;

/* LD r1, r2 -------------------------------------------------------------- */
case 0x78: sprintf(out, "LD A, B\n"); break;
case 0x79: sprintf(out, "LD A, C\n"); break;
case 0x7A: sprintf(out, "LD A, D\n"); break;
case 0x7B: sprintf(out, "LD A, E\n"); break;
case 0x7C: sprintf(out, "LD A, H\n"); break;
case 0x7D: sprintf(out, "LD A, L\n"); break;
case 0x7E: sprintf(out, "LD A, (HL)\n"); break;

case 0x40: sprintf(out, "LD B, B\n"); break;
case 0x41: sprintf(out, "LD B, C\n"); break;
case 0x42: sprintf(out, "LD B, D\n"); break;
case 0x43: sprintf(out, "LD B, E\n"); break;
case 0x44: sprintf(out, "LD B, H\n"); break;
case 0x45: sprintf(out, "LD B, L\n"); break;
case 0x46: sprintf(out, "LD B, (HL)\n"); break;

case 0x48: sprintf(out, "LD C, B\n"); break;
case 0x49: sprintf(out, "LD C, C\n"); break;
case 0x4A: sprintf(out, "LD C, D\n"); break;
case 0x4B: sprintf(out, "LD C, E\n"); break;
case 0x4C: sprintf(out, "LD C, H\n"); break;
case 0x4D: sprintf(out, "LD C, L\n"); break;
case 0x4E: sprintf(out, "LD C, (HL)\n"); break;

case 0x50: sprintf(out, "LD D, B\n"); break;
case 0x51: sprintf(out, "LD D, C\n"); break;
case 0x52: sprintf(out, "LD D, D\n"); break;
case 0x53: sprintf(out, "LD D, E\n"); break;
case 0x54: sprintf(out, "LD D, H\n"); break;
case 0x55: sprintf(out, "LD D, L\n"); break;
case 0x56: sprintf(out, "LD D, (HL)\n"); break;

case 0x60: sprintf(out, "LD H, B\n"); break;
case 0x61: sprintf(out, "LD H, C\n"); break;
case 0x62: sprintf(out, "LD H, D\n"); break;
case 0x63: sprintf(out, "LD H, E\n"); break;
case 0x64: sprintf(out, "LD H, H\n"); break;
case 0x65: sprintf(out, "LD H, L\n"); break;
case 0x66: sprintf(out, "LD H, (HL)\n"); break;

case 0x68: sprintf(out, "LD L, B\n"); break;
case 0x69: sprintf(out, "LD L, C\n"); break;
case 0x6A: sprintf(out, "LD L, D\n"); break;
case 0x6B: sprintf(out, "LD L, E\n"); break;
case 0x6C: sprintf(out, "LD L, H\n"); break;
case 0x6D: sprintf(out, "LD L, A\n"); break;
case 0x6E: sprintf(out, "LD L, (HL)\n"); break;

case 0x70: sprintf(out, "LD (HL), B\n"); break;
case 0x71: sprintf(out, "LD (HL), C\n"); break;
case 0x72: sprintf(out, "LD (HL), D\n"); break;
case 0x73: sprintf(out, "LD (HL), E\n"); break;
case 0x74: sprintf(out, "LD (HL), H\n"); break;
case 0x75: sprintf(out, "LD (HL), L\n"); break;
case 0x36: sprintf(out, "LD (HL), %.2x\n", READ_B(offset++)); break;

/* LD A, n ------------------------------------------------------------- */
case 0x7F: sprintf(out, "LD A, A\n"); break;
case 0x0A: sprintf(out, "LD A, (BC)\n"); break;
case 0x1A: sprintf(out, "LD A, (DE)\n"); break;
case 0x3E: sprintf(out, "LD A, %.2x\n", READ_B(offset++)); break;
case 0xFA: sprintf(out, "LD A, (%.4x)\n", READ_W(offset)); offset+=2; break;

/* LD n, A ------------------------------------------------------------- */
case 0x47: sprintf(out, "LD B, A\n"); break;
case 0x4F: sprintf(out, "LD C, A\n"); break;
case 0x57: sprintf(out, "LD D, A\n"); break;
case 0x5F: sprintf(out, "LD E, A\n"); break;
case 0x67: sprintf(out, "LD H, A\n"); break;
case 0x6F: sprintf(out, "LD L, A\n"); break;
case 0x02: sprintf(out, "LD (BC), A\n"); break;
case 0x12: sprintf(out, "LD (DE), A\n"); break;
case 0x77: sprintf(out, "LD (HL), A\n"); break;
case 0xEA: sprintf(out, "LD (%.4x), A\n", READ_W(offset)); offset++; break;

/* LD A, (FF00+C) ----------------------------------------------------- */
case 0xF2: sprintf(out, "LD A, (FF00+C)\n"); break;

/* LD (FF00+C), A ----------------------------------------------------- */
case 0xE2: sprintf(out, "LD (FF00+C), A\n"); break;

/* LDD A, (HL) -------------------------------------------------------- */
case 0x3A: sprintf(out, "LDD A, (HL)\n"); break;

/* LDD (HL), A -------------------------------------------------------- */
case 0x32: sprintf(out, "LDD (HL), A\n"); break;

/* LDI A, (HL) -------------------------------------------------------- */
case 0x2A: sprintf(out, "LDI A, (HL)\n"); break;

/* LDI (HL), A -------------------------------------------------------- */
case 0x22: sprintf(out, "LDI (HL), A\n"); break;

/* LD (FF00+n), A ----------------------------------------------------- */
case 0xE0: sprintf(out, "LD (FFOO+%.2x), A\n", READ_B(offset++)); break;

/* LD A, (FF00+n) ----------------------------------------------------- */
case 0xF0: sprintf(out, "LD A, (FFOO+%.2x)\n", READ_B(offset++)); break;

/* LD n, nn ------------------------------------------------------------- */
case 0x01: sprintf(out, "LD BC, %.4x\n", READ_W(offset)); offset+=2; break;
case 0x11: sprintf(out, "LD DE, %.4x\n", READ_W(offset)); offset+=2; break;
case 0x21: sprintf(out, "LD HL, %.4x\n", READ_W(offset)); offset+=2; break;
case 0x31: sprintf(out, "LD SP, %.4x\n", READ_W(offset)); offset+=2; break;
case 0xF9: sprintf(out, "LD SP, HL\n"); break;

/* LDHL SP, n ----------------------------------------------------------- */
case 0xF8: sprintf(out, "LDHL SP, %.2x\n", READ_B(offset++)); break;

/* LD (nn), SP ---------------------------------------------------------- */
case 0x08: sprintf(out, "LD (%.4x), SP\n", READ_W(offset)); offset+=2; break;

/* PUSH nn -------------------------------------------------------------- */
case 0xF5: sprintf(out, "PUSH AF\n"); break;
case 0xC5: sprintf(out, "PUSH BC\n"); break;
case 0xD5: sprintf(out, "PUSH DE\n"); break;
case 0xE5: sprintf(out, "PUSH HL\n"); break;

/* POP nn -------------------------------------------------------------- */
case 0xF1: sprintf(out, "POP AF\n"); break;
case 0xC1: sprintf(out, "POP BC\n"); break;
case 0xD1: sprintf(out, "POP DE\n"); break;
case 0xE1: sprintf(out, "POP HL\n"); break;

/* ADD A, nn ----------------------------------------------------------- */
case 0x87: sprintf(out, "ADD A, A\n"); break;
case 0x80: sprintf(out, "ADD A, B\n"); break;
case 0x81: sprintf(out, "ADD A, C\n"); break;
case 0x82: sprintf(out, "ADD A, D\n"); break;
case 0x83: sprintf(out, "ADD A, E\n"); break;
case 0x84: sprintf(out, "ADD A, H\n"); break;
case 0x85: sprintf(out, "ADD A, L\n"); break;
case 0x86: sprintf(out, "ADD A, (HL)\n"); break;
case 0xC6: sprintf(out, "ADD A, %.2x\n", READ_B(offset++)); break;

/* ADC A, nn ----------------------------------------------------------- */
case 0x8F: sprintf(out, "ADC A, A\n"); break;
case 0x88: sprintf(out, "ADC A, B\n"); break;
case 0x89: sprintf(out, "ADC A, C\n"); break;
case 0x8A: sprintf(out, "ADC A, D\n"); break;
case 0x8B: sprintf(out, "ADC A, E\n"); break;
case 0x8C: sprintf(out, "ADC A, H\n"); break;
case 0x8D: sprintf(out, "ADC A, L\n"); break;
case 0x8E: sprintf(out, "ADC A, (HL)\n"); break;
case 0xCE: sprintf(out, "ADC A, %.2x\n", READ_B(offset++)); break;

/* SUB A, nn ----------------------------------------------------------- */
case 0x97: sprintf(out, "SUB A, A\n"); break;
case 0x90: sprintf(out, "SUB A, B\n"); break;
case 0x91: sprintf(out, "SUB A, C\n"); break;
case 0x92: sprintf(out, "SUB A, D\n"); break;
case 0x93: sprintf(out, "SUB A, E\n"); break;
case 0x94: sprintf(out, "SUB A, H\n"); break;
case 0x95: sprintf(out, "SUB A, L\n"); break;
case 0x96: sprintf(out, "SUB A, (HL)\n"); break;
case 0xD6: sprintf(out, "SUB A, %.2x\n", READ_B(offset++)); break;

/* SBC A, nn ----------------------------------------------------------- */
case 0x9F: sprintf(out, "SBC A, A\n"); break;
case 0x98: sprintf(out, "SBC A, B\n"); break;
case 0x99: sprintf(out, "SBC A, C\n"); break;
case 0x9A: sprintf(out, "SBC A, D\n"); break;
case 0x9B: sprintf(out, "SBC A, E\n"); break;
case 0x9C: sprintf(out, "SBC A, H\n"); break;
case 0x9D: sprintf(out, "SBC A, L\n"); break;
case 0x9E: sprintf(out, "SBC A, (HL)\n"); break;
case 0xDE: sprintf(out, "SBC A, %.2x\n", READ_B(offset++)); break;

/* AND n -------------------------------------------------------------- */
case 0xA7: sprintf(out, "AND A\n"); break;
case 0xA0: sprintf(out, "AND B\n"); break;
case 0xA1: sprintf(out, "AND C\n"); break;
case 0xA2: sprintf(out, "AND D\n"); break;
case 0xA3: sprintf(out, "AND E\n"); break;
case 0xA4: sprintf(out, "AND H\n"); break;
case 0xA5: sprintf(out, "AND L\n"); break;
case 0xA6: sprintf(out, "AND (HL)\n"); break;
case 0xE6: sprintf(out, "AND %.2x\n", READ_B(offset++)); break;

/* OR n -------------------------------------------------------------- */
case 0xB7: sprintf(out, "OR A\n"); break;
case 0xB0: sprintf(out, "OR B\n"); break;
case 0xB1: sprintf(out, "OR C\n"); break;
case 0xB2: sprintf(out, "OR D\n"); break;
case 0xB3: sprintf(out, "OR E\n"); break;
case 0xB4: sprintf(out, "OR H\n"); break;
case 0xB5: sprintf(out, "OR L\n"); break;
case 0xB6: sprintf(out, "OR (HL)\n"); break;
case 0xF6: sprintf(out, "OR %.2x\n", READ_B(offset++)); break;

/* XOR n ------------------------------------------------------------ */
case 0xAF: sprintf(out, "XOR A\n"); break;
case 0xA8: sprintf(out, "XOR B\n"); break;
case 0xA9: sprintf(out, "XOR C\n"); break;
case 0xAA: sprintf(out, "XOR D\n"); break;
case 0xAB: sprintf(out, "XOR E\n"); break;
case 0xAC: sprintf(out, "XOR H\n"); break;
case 0xAD: sprintf(out, "XOR L\n"); break;
case 0xAE: sprintf(out, "XOR (HL)\n"); break;
case 0xEE: sprintf(out, "XOR %.2x\n", READ_B(offset++)); break;

/* CP n ------------------------------------------------------------ */
case 0xBF: sprintf(out, "CP A\n"); break;
case 0xB8: sprintf(out, "CP B\n"); break;
case 0xB9: sprintf(out, "CP C\n"); break;
case 0xBA: sprintf(out, "CP D\n"); break;
case 0xBB: sprintf(out, "CP E\n"); break;
case 0xBC: sprintf(out, "CP H\n"); break;
case 0xBD: sprintf(out, "CP L\n"); break;
case 0xBE: sprintf(out, "CP (HL)\n"); break;
case 0xFE: sprintf(out, "CP %.2x\n", READ_B(offset++)); break;

/* INC n ----------------------------------------------------------- */
case 0x3C: sprintf(out, "INC A\n"); break;
case 0x04: sprintf(out, "INC B\n"); break;
case 0x0C: sprintf(out, "INC C\n"); break;
case 0x14: sprintf(out, "INC D\n"); break;
case 0x1C: sprintf(out, "INC E\n"); break;
case 0x24: sprintf(out, "INC H\n"); break;
case 0x2C: sprintf(out, "INC L\n"); break;
case 0x34: sprintf(out, "INC (HL)\n"); break;

/* DEC n ----------------------------------------------------------- */
case 0x3D: sprintf(out, "DEC A\n"); break;
case 0x05: sprintf(out, "DEC B\n"); break;
case 0x0D: sprintf(out, "DEC C\n"); break;
case 0x15: sprintf(out, "DEC D\n"); break;
case 0x1D: sprintf(out, "DEC E\n"); break;
case 0x25: sprintf(out, "DEC H\n"); break;
case 0x2D: sprintf(out, "DEC L\n"); break;
case 0x35: sprintf(out, "DEC (HL)\n"); break;

/* ADD HL, nn ------------------------------------------------------ */
case 0x09: sprintf(out, "ADD HL, BC\n"); break;
case 0x19: sprintf(out, "ADD HL, DE\n"); break;
case 0x29: sprintf(out, "ADD HL, HL\n"); break;
case 0x39: sprintf(out, "ADD HL, SP\n"); break;

/* ADD SP, n ------------------------------------------------------ */
case 0xE8: sprintf(out, "ADD SP, %.2x\n", READ_B(offset++)); break;

/* INC nn --------------------------------------------------------- */
case 0x03: sprintf(out, "INC BC\n"); break;
case 0x13: sprintf(out, "INC DE\n"); break;
case 0x23: sprintf(out, "INC HL\n"); break;
case 0x33: sprintf(out, "INC SP\n"); break;

/* DEC nn --------------------------------------------------------- */
case 0x0B: sprintf(out, "DEC BC\n"); break;
case 0x1B: sprintf(out, "DEC DE\n"); break;
case 0x2B: sprintf(out, "DEC HL\n"); break;
case 0x3B: sprintf(out, "DEC SP\n"); break;

/* DAA ------------------------------------------------------------ */
case 0x27: sprintf(out, "DAA\n"); break;

/* CPL ------------------------------------------------------------ */
case 0x2F: sprintf(out, "CPL A\n"); break;

/* CCF ------------------------------------------------------------ */
case 0x3F: sprintf(out, "CCF\n"); break;

/* SCF ------------------------------------------------------------ */
case 0x37: sprintf(out, "SCF\n"); break;

/* NOP ------------------------------------------------------------ */
case 0x00: sprintf(out, "NOP\n"); break;

/* HALT ----------------------------------------------------------- */
case 0x76: sprintf(out, "HALT\n"); break;

/* DI/EI ---------------------------------------------------------- */
case 0xF3: sprintf(out, "DI\n"); break;
case 0xFB: sprintf(out, "EI\n"); break;

/* RLCA ----------------------------------------------------------- */
case 0x07: sprintf(out, "RLCA\n"); break;
case 0x17: sprintf(out, "RLA\n"); break;
case 0x0F: sprintf(out, "RRCA\n"); break;
case 0x1F: sprintf(out, "RRA\n"); break;

/* JP nn ---------------------------------------------------------- */
case 0xC3: sprintf(out, "JP %.4x\n", READ_W(offset)); offset+=2; break;

/* JP cc, nn ------------------------------------------------------ */
case 0xC2: sprintf(out, "JP NZ, %.4x\n", READ_W(offset)); offset+=2; break;
case 0xCA: sprintf(out, "JP Z, %.4x\n", READ_W(offset)); offset+=2; break;
case 0xD2: sprintf(out, "JP NC, %.4x\n", READ_W(offset)); offset+=2; break;
case 0xDA: sprintf(out, "JP C, %.4x\n", READ_W(offset)); offset+=2; break;

/* JP (HL) -------------------------------------------------------- */
case 0xE9: sprintf(out, "JP (HL)\n"); break;

/* JR n ----------------------------------------------------------- */
case 0x18: sprintf(out, "JR %.4x\n", ((signed)offset)+((signed)READ_B(offset++))); break;

/* JR cc, n ------------------------------------------------------- */
#define n8 signed char

case 0x20: sprintf(out, "JR NZ, %.4x\n", ((signed)offset)+((n8)READ_B(offset++))); break;
case 0x28: sprintf(out, "JR Z, %.4x\n", ((signed)offset)+((n8)READ_B(offset++))); break;
case 0x30: sprintf(out, "JR NC, %.4x\n", ((signed)offset)+((n8)READ_B(offset++))); break;
case 0x38: sprintf(out, "JR C, %.4x\n", ((signed)offset)+((n8)READ_B(offset++))); break;

/* CALL nn ------------------------------------------------------- */
case 0xCD: sprintf(out, "CALL %.4x\n", READ_W(offset)); offset+=2; break;

/* CALL cc, nn ------------------------------------------------------- */
case 0xC4: sprintf(out, "CALL NZ, %.4x\n", READ_W(offset)); offset+=2; break;
case 0xCC: sprintf(out, "CALL Z, %.4x\n", READ_W(offset)); offset+=2; break;
case 0xD4: sprintf(out, "CALL NC, %.4x\n", READ_W(offset)); offset+=2; break;
case 0xDC: sprintf(out, "CALL C, %.4x\n", READ_W(offset)); offset+=2; break;

/* RST n --------------------------------------------------------- */
case 0xC7: sprintf(out, "RST 00\n"); break;
case 0xCF: sprintf(out, "RST 08\n"); break;
case 0xD7: sprintf(out, "RST 10\n"); break;
case 0xDF: sprintf(out, "RST 18\n"); break;
case 0xE7: sprintf(out, "RST 20\n"); break;
case 0xEF: sprintf(out, "RST 28\n"); break;
case 0xF7: sprintf(out, "RST 30\n"); break;
case 0xFF: sprintf(out, "RST 38\n"); break;

/* RET ----------------------------------------------------------- */
case 0xC9: sprintf(out, "RET\n"); break;
case 0xD9: sprintf(out, "RETI\n"); break;

case 0xC0: sprintf(out, "RET NZ\n"); break;
case 0xC8: sprintf(out, "RET Z\n"); break;
case 0xD0: sprintf(out, "RET NC\n"); break;
case 0xD8: sprintf(out, "RET C\n"); break;


































